package com.example.kazuhirokondou.androidsextant;

import android.content.Context;
import android.hardware.Camera;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

import java.util.HashMap;

import static com.example.kazuhirokondou.androidsextant.R.id.MS_SendSignaleditText;
import static com.example.kazuhirokondou.androidsextant.R.id.MS_sendsignalbutton;
import static com.example.kazuhirokondou.androidsextant.R.id.action_settings;


public class MorseSignalActivity extends ActionBarActivity implements View.OnClickListener {
    private static final String DEBUG_TAG = "MorseSignalAct:";
    private static HashMap<String,String> msmap = new HashMap<>();
    private Camera camera = null;
    private Camera.Parameters params;
    private int count = 0;
    private final Context context = this;
//    private final Handler handler = new Handler();
//    private final Runnable LightOffTask = new Runnable() {
//        @Override
//        public void run() {
//            //パラメータ取得
//            params = camera.getParameters();
//            //フラッシュモードを消灯に設定
//            params.setFlashMode(Camera.Parameters.FLASH_MODE_OFF);
//            //パラメータ設定
//            camera.setParameters(params);
//        }
//    };

    static void setmssignal(){
        msmap.put("a","102");
        msmap.put("b","2010101");
        msmap.put("c","2010201");
        msmap.put("d","20101");
        msmap.put("e","1");
        msmap.put("f","1010201");
        msmap.put("g","20201");
        msmap.put("h","1010101");
        msmap.put("i","101");
        msmap.put("j","1020202");
        msmap.put("k","20102");
        msmap.put("l","1020101");
        msmap.put("m","202");
        msmap.put("n","201");
        msmap.put("o","20202");
        msmap.put("p","1020201");
        msmap.put("q","2020102");
        msmap.put("r","10201");
        msmap.put("s","10101");
        msmap.put("t","2");
        msmap.put("u","10102");
        msmap.put("v","1010102");
        msmap.put("w","10202");
        msmap.put("x","2010102");
        msmap.put("y","2010202");
        msmap.put("z","2020101");
        msmap.put("1","102020202");
        msmap.put("2","101020202");
        msmap.put("3","101010202");
        msmap.put("4","101010102");
        msmap.put("5","101010101");
        msmap.put("6","201010101");
        msmap.put("7","202010101");
        msmap.put("8","202020101");
        msmap.put("9","202020201");
        msmap.put("0","202020202");
        msmap.put(".","10201020102");
        msmap.put(",","20201010202");
        msmap.put("?","10102020101");
        msmap.put("!","20102010202");
        msmap.put("-","20101010102");
        msmap.put("/","201010201");
        msmap.put("@","10202010201");
        msmap.put("(","201020201");
        msmap.put(")","20102020102");
        msmap.put(" ","0");
        msmap.put("ｱ","202010202");
        msmap.put("ｲ","102");
        msmap.put("ｳ","10102");
        msmap.put("ｴ","201020202");
        msmap.put("ｵ","102010101");
        msmap.put("ｶ","1020101");
        msmap.put("ｷ","201020101");
        msmap.put("ｸ","1010102");
        msmap.put("ｹ","2010202");
        msmap.put("ｺ","2020202");
        msmap.put("ｻ","201020102");
        msmap.put("ｼ","202010201");
        msmap.put("ｽ","202020102");
        msmap.put("ｾ","102020201");
        msmap.put("ｿ","2020201");
        msmap.put("ﾀ","201");
        msmap.put("ﾁ","1010201");
        msmap.put("ﾂ","1020201");
        msmap.put("ﾃ","102010202");
        msmap.put("ﾄ","101020101");
        msmap.put("ﾅ","10201");
        msmap.put("ﾆ","2010201");
        msmap.put("ﾇ","1010101");
        msmap.put("ﾈ","2020102");
        msmap.put("ﾉ","1010202");
        msmap.put("ﾊ","2010101");
        msmap.put("ﾋ","202010102");
        msmap.put("ﾌ","2020101");
        msmap.put("ﾍ","1");
        msmap.put("ﾎ","20101");
        msmap.put("ﾏ","2010102");
        msmap.put("ﾐ","101020102");
        msmap.put("ﾑ","2");
        msmap.put("ﾒ","201010102");
        msmap.put("ﾓ","201010201");
        msmap.put("ﾔ","10202");
        msmap.put("ﾕ","201010202");
        msmap.put("ﾖ","202");
        msmap.put("ﾗ","10101");
        msmap.put("ﾘ","20201");
        msmap.put("ﾙ","201020201");
        msmap.put("ﾚ","20202");
        msmap.put("ﾛ","1020102");
        msmap.put("ﾜ","20102");
        msmap.put("ｦ","1020202");
        msmap.put("ﾝ","102010201");
        msmap.put("ﾞ","101");
        msmap.put("ﾟ","101020201");

    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_morse_signal);

        //モールス信号の連相変数を設定
        setmssignal();

        Button sendbutton = (Button) findViewById(MS_sendsignalbutton);
        sendbutton.setOnClickListener(this);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if(camera != null){
            //カメラデバイス動作停止
            camera.stopPreview();
            //カメラデバイス解放
            camera.release();
            camera = null;
        }

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_morse_signal, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onClick(View v) {
        switch(v.getId()){
            case MS_sendsignalbutton:
                EditText ed = (EditText) findViewById(MS_SendSignaleditText);
                ed.selectAll();
                String sendsignaltxt = ed.getText().toString();
                Log.d(DEBUG_TAG, "onClick :"+sendsignaltxt);
                sendsignaltxt = convstr2morse(sendsignaltxt);
                Log.d(DEBUG_TAG, "convstr2morse :"+sendsignaltxt);
//                Toast.makeText(this, sendsignaltxt, Toast.LENGTH_LONG).show();
                sendsignal(sendsignaltxt);
                break;
            default:
        }
    }

    //引数をモールス信号の文字列に変換
    public String convstr2morse(String signal){
//        final String METHOD_TAG = "convstr2morse";
        //モールス信号初期値に0を設定して最初に必ず少し待つ
        String morse_signal="";
        //引数を小文字のみに変換
        signal = signal.toLowerCase();
        //引数の長さ取得
        int signal_len = signal.length();
//        Log.d(DEBUG_TAG+METHOD_TAG, " signal.length()  :"+signal_len);
        for(int i = 0;i<signal_len;i++){
            String c = String.valueOf(signal.charAt(i));
//            Log.d(DEBUG_TAG+METHOD_TAG, " char c =  :"+c);
            for(String key : msmap.keySet()){
                if(key.equals(c)){
//                    Log.d(DEBUG_TAG+METHOD_TAG, "msmap.get(c) :"+msmap.get(c));
                    morse_signal = morse_signal + "0" + msmap.get(c);
                }
            }
        }
        return morse_signal;
    }

    //変換後のモールス信号を発信
    public void sendsignal(String signal){
        final String METHOD_TAG = "sendsignal";
        //カメラデバイス取得
        camera = Camera.open();
        //カメラデバイス動作開始
        camera.startPreview();
        //LEDを初期化
        params = camera.getParameters();
        params.setFlashMode(Camera.Parameters.FLASH_MODE_OFF);
        camera.setParameters(params);
//        handler.post(LightOffTask);

        //引数の長さ取得
        int signal_len = signal.length();
        for(int i = 0;i<signal_len;i++) {
            String c = String.valueOf(signal.charAt(i));
            Log.d(DEBUG_TAG+METHOD_TAG, "String c =  :"+c);
            switch(c){
                case "0":
//                    handler.postAtTime(LightOffTask,5000);
                    waitingsignal(100);
                    Log.d(DEBUG_TAG+METHOD_TAG, "case 0");
                    break;
                case "1":
                    //フラッシュモードを点灯に設定
                    params = camera.getParameters();
                    params.setFlashMode(Camera.Parameters.FLASH_MODE_TORCH);
                    camera.setParameters(params);
//                    handler.postAtTime(LightOffTask,5000);

                    //モールス信号の長さ指定
                    waitingsignal(100);
                    Log.d(DEBUG_TAG+METHOD_TAG, "case 1");
                    break;
                case "2":
                    //フラッシュモードを点灯に設定
                    params = camera.getParameters();
                    params.setFlashMode(Camera.Parameters.FLASH_MODE_TORCH);
                    camera.setParameters(params);

//                    handler.postAtTime(LightOffTask,15000);
                    //モールス信号の長さ指定
                    waitingsignal(300);
                    Log.d(DEBUG_TAG+METHOD_TAG, "case 2");
                    break;
                default:
            }
            //フラッシュモードを消灯に設定
            params = camera.getParameters();
            params.setFlashMode(Camera.Parameters.FLASH_MODE_OFF);
            camera.setParameters(params);

        }
        //カメラデバイス動作停止
        camera.stopPreview();
        //カメラデバイス解放
        camera.release();
        camera = null;

    }

    //モールス信号の間隔
    public synchronized void waitingsignal(long msec)
    {	//指定ミリ秒実行を止めるメソッド
        try
        {
            wait(msec);
        }catch(InterruptedException e){}
    }

}
